import chimera, numpy
from chimera import runCommand
from numpy import array as ar, random as rn

from StructBio.Utilities.miscFunctions import colorByName
from StructBio.Graphs.graph import Graph, Node, Edge

runCommand("set bg_color white")

g = Graph()

g.addNode("A", Node(1.0, ar((1.0, 0.0, 0.0)), 0.7, colorByName("dark red")))
g.addNode("C", Node(1.0, ar((9.0, 1.0, 0.0)), 0.7, colorByName("red")))
g.addNode("E", Node(1.0, ar((1.0, 0.0, 9.0)), 0.7, colorByName("orange red")))
g.addNode("G", Node(1.0, ar((2.0, 7.0, 9.0)), 0.7, colorByName("violet red")))
g.addNode("B", Node(3.2, ar((0.0, 8.0, 2.0)), 0.7, colorByName("dark green")))
g.addNode("D", Node(3.4, ar((9.0, 8.0, 1.0)), 0.7, colorByName("spring green")))
g.addNode("F", Node(3.5, ar((8.0, 2.0, 7.0)), 0.7, colorByName("lime green")))
g.addNode("H", Node(3.7, ar((7.0, 6.0, 8.0)), 0.7, colorByName("light green")))

for n in g.vertices_D.keys():
    for m in g.vertices_D.keys():
        if n <= m: continue
        if rn.random() < 0.5:
            spnd_color = tuple((ar(g.vertices_D[n].color) +
                                ar(g.vertices_D[m].color))/2.0)            
            g.addEdge(n, m, Edge(0.0, 0.3, spnd_color))

g.solids.display()

redG = g.getSubgraph_NodeWeightsWithinRange(1.0, 1.0, "Reddish subgraph")
redG.solids.display()

greenG = g.getSubgraph_NodeWeightsWithinRange(3.0, 4.0, "Greenish subgraph")
greenG.solids.display()


