import chimera, numpy
from chimera import runCommand
from numpy import array, random as rn
from StructBio.Graphs.graph import Graph, Node, Edge

runCommand("set bg_color white")

maxX = 32.; maxY = 16.; maxZ = 16.
numNodes = 12

g = Graph("Delaunay Tessellation")

for ix in range(numNodes):
    c = array((rn.random()*maxX, rn.random()*maxY, rn.random()*maxZ))
    nd = Node(0.0, c, 0.7, tuple((rn.random(), rn.random(), rn.random())))
    g.addNode("V" + "%03d"%ix, nd)

g.buildDelaunayTessellation(15.0)
g.solids.display()


